/*******************************************************************

   program pro vodomerku

*******************************************************************/
/*** BeginHeader  */

#class auto
#memmap xmem

// obecne
	#use VODOMERKA_RCM54xxW.LIB
	#use VODOMERKA_LED.LIB
	#use VODOMERKA_MEASURE.lib
	#use VODOMERKA_FUNCTIONS.LIB

// FAT
	#define FAT_BLOCK
	#define FAT_USE_FORWARDSLASH
	#use fat.lib

// WiFi a LAN config
	#define USE_DHCP
	#define TCPCONFIG 5
	#use "dcrtcp.lib"

// FTP  HTTP
	#define SSPEC_MAXSPEC 10
	//#define SSPEC_FLASHRULES
	//#define FTP_EXTENSIONS
	//#define FTP_MAXSERVERS 2
	//#define HTTP_NO_FLASHSPEC
	//#define SSPEC_NO_STATIC
	//#define SSPEC_USERSPERRESOURCE    4
	#define HTTP_MAXSERVERS 2
	//#define MAX_SOCKETS 8
	//#define MAX_TCP_SOCKET_BUFFERS 4
	//#define MAX_UDP_SOCKET_BUFFERS 4

	#define FTP_ADMIN		0x0001	// Group mask for user(s) which can perform uploads


// ZHTML
	#define USE_RABBITWEB 1
	#use http.lib

// SERIAL
	#define XINBUFSIZE   127
	#define XOUTBUFSIZE  127

/*** EndHeader  */

// -------------------------------------------------------------------------

// Global Variables etc


/*** BeginHeader  */
#define MY_DEBUG
//#define MY_DEBUG_10 // zapsani na nejblizsi prvek, kdzy mereni je casteji nez 10min

#define DEVICE_IDENT "MAR"
#define MEAS_STRUCT_NAME  	"S_W_MAR.TXT"
#define WATER_24_XML     	"W_24_MAR.XML"
#define TEMP_24_XML  		"T_24_MAR.XML"
#define EXT_24_XML   		"E_24_MAR.XML"
#define WATER_W_XML     	"W_W_MAR.XML"
#define TEMP_W_XML  			"T_W_MAR.XML"
#define EXT_W_XML   			"E_W_MAR.XML"
#define OPT_NAME				"OPT_MAR.OPT"
#define LOG_NAME           "LOG_MAR.TXT"
#define ACTUAL_VALUES		"ACT_MAR.TXT"

#define XML_SERIES_NAME  "<row>\n<string>Marklovice</string>\n"


/*** EndHeader  */

// -------------------------------------------------------------------------

typedef struct {
		char tm_sec; // seconds 0-59
		char tm_min; // 0-59
		char tm_hour; // 0-23
		char tm_mday; // 1-31
		char tm_mon; // 1-12
		char tm_year; // 80-147 (1980-2047)
		char tm_wday; // 0-6 0==sunday
}tm_typ;

typedef struct {
		int tm_sec; // seconds 0-59
		int tm_min; // 0-59
		int tm_hour; // 0-23
		int tm_mday; // 1-31
		int tm_mon; // 1-12
		int tm_year; // 80-147 (1980-2047)
		int tm_wday; // 0-6 0==sunday
}int_tm_typ;


typedef struct{
	long time[1008];				// 144 for measuring by 10min/day
   float water[1008];
   float temp[1008];
   float ext_temp[1008];
   int last_write;
} week_t;

//WiFi
typedef struct{
	   long ipaddr;
	   long netmask;
	   long router_set;
	   int dhcp;
 	   char wifi_ssid[20];
	   int wifi_tx_rate; // 0-15
	   int wifi_tx_power;
      int http_port;
} wifi_opt_t;


//OPTIONS
typedef struct{
	//measure
   	float t_cal, q_cal, k_cal;
   //wifi
      wifi_opt_t wifi[3];
      int wifi_opt_num;
		int wifi_opt_conf;
} options_t;

//-------------------------------------------------------------------------

tm_typ up_time;
int_tm_typ int_up_time;

fat_part *partition;
long meas_sec_timer;

int file_user_id, web_user_id;

//serial congig variables
	char term_var_value[50]; // example: 10.0.0.23
	char term_var_ident[4];  // example: x10
	char ser_buf[100];
	char uni_buf[20];

// measure variables
	week_t meas_week;
	protected options_t opt;
	float int_temp, ext_temp;
	unsigned int adc_value[4];
	float meas_values[6];  // 0-water, 1-5V, 2-3.3V, 3-RSSI, 4-temp, 5-ext. temp

//log variables
	protected char last_err[128];
	protected char fix_err; // 1 = format
	protected int reset_count;
//web variables
	float q_new;
	char yes_format, yes_reset_meas;

   char web_ipaddr[17];
   char web_netmask[17];
   char web_router[17];
   int  web_dhcp, web_tx_pwr, web_tx_rate, web_http_port;
   char web_ssid[20];

//-------------------------------------------------------------------------

#ximport "RCM_Vodomerka_project_2/zpages/index.zhtml"					index_zhtml
#ximport "RCM_Vodomerka_project_2/zpages/time_form.zhtml"         time_zhtml
#ximport "RCM_Vodomerka_project_2/zpages/measure_form.zhtml"      measure_zhtml
#ximport "RCM_Vodomerka_project_2/zpages/wifi_form.zhtml"      	wifi_zhtml

#ximport "RCM_Vodomerka_project_2/zpages/house.gif"             house_gif
#ximport "RCM_Vodomerka_project_2/zpages/clock.gif"             clock_gif
#ximport "RCM_Vodomerka_project_2/zpages/meter.gif"             meter_gif
#ximport "RCM_Vodomerka_project_2/zpages/wifi.gif"              wifi_gif

//-------------------------------------------------------------------------

SSPEC_MIMETABLE_START
   SSPEC_MIME_FUNC(".zhtml", "text/html", zhtml_handler),
	SSPEC_MIME(".html", "text/html"),
	SSPEC_MIME(".gif", "image/gif"),
SSPEC_MIMETABLE_END

SSPEC_RESOURCETABLE_START
	SSPEC_RESOURCE_XMEMFILE("/admin/index.zhtml", index_zhtml),
	SSPEC_RESOURCE_XMEMFILE("/admin/time_f.zhtml", time_zhtml),
	SSPEC_RESOURCE_XMEMFILE("/admin/meas_f.zhtml", measure_zhtml),
	SSPEC_RESOURCE_XMEMFILE("/admin/wifi_f.zhtml", wifi_zhtml),
   SSPEC_RESOURCE_XMEMFILE("/admin/house.gif", house_gif),
	SSPEC_RESOURCE_XMEMFILE("/admin/clock.gif", clock_gif),
   SSPEC_RESOURCE_XMEMFILE("/admin/meter.gif", meter_gif),
   SSPEC_RESOURCE_XMEMFILE("/admin/wifi.gif", wifi_gif),
SSPEC_RESOURCETABLE_END

//-------------------------------------------------------------------------

#web_groups web_admin

#web up_time groups = web_admin
#web int_up_time groups = web_admin
#web int_up_time.tm_sec ( ($int_up_time.tm_sec >= 0) && ($int_up_time.tm_sec < 60) ) groups = web_admin
#web int_up_time.tm_min ( ($int_up_time.tm_min >= 0) && ($int_up_time.tm_min < 60) ) groups = web_admin
#web int_up_time.tm_hour ( ($int_up_time.tm_hour >= 0) && ($int_up_time.tm_hour < 24) ) groups = web_admin
#web int_up_time.tm_mday ( ($int_up_time.tm_mday >= 1) && ($int_up_time.tm_mday <= 31) ) groups = web_admin
#web int_up_time.tm_mon ( ($int_up_time.tm_mon >= 1) && ($int_up_time.tm_mon <= 12) )   groups = web_admin
#web int_up_time.tm_year ( ($int_up_time.tm_year >= 80) && ($int_up_time.tm_year <= 147) )  groups = web_admin

#web_update int_up_time.tm_sec set_time
#web_update int_up_time.tm_min set_time
#web_update int_up_time.tm_hour set_time
#web_update int_up_time.tm_mday set_time
#web_update int_up_time.tm_mon set_time
#web_update int_up_time.tm_year set_time


#web opt.q_cal groups = web_admin
#web opt.t_cal groups = web_admin
#web q_new groups = web_admin
#web_update q_new calibrate

#web yes_format  (($yes_format == 'Y') || ($yes_format == 'N') ) groups = web_admin
#web yes_reset_meas (($yes_reset_meas == 'Y') || ($yes_reset_meas == 'N') ) groups = web_admin
#web_update yes_format format
#web_update yes_reset_meas meas_struct_init

#web meas_values groups = web_admin

#web opt groups = web_admin
#web opt.wifi_opt_num ( ($opt.wifi_opt_num >= 0) & ($opt.wifi_opt_num < 3) ) groups = web_admin
#web opt.wifi_opt_conf ( ($opt.wifi_opt_num >= 0) & ($opt.wifi_opt_num < 3) ) groups = web_admin

#web opt.wifi groups = web_admin

#web web_ipaddr 	groups = web_admin
#web web_netmask 	groups = web_admin
#web web_router 	groups = web_admin
#web web_dhcp 		groups = web_admin
#web web_tx_pwr 	groups = web_admin
#web web_tx_rate 	groups = web_admin
#web web_http_port groups = web_admin
#web web_ssid groups = web_admin
/*#web opt.wifi[opt.wifi_opt_conf].dhcp groups = web_admin
#web opt.wifi[opt.wifi_opt_conf].wifi_tx_power groups = web_admin
#web opt.wifi[opt.wifi_opt_conf].wifi-tx_rate groups = web_admin
#web opt.wifi[opt.wifi_opt_conf].http_port groups = web_admin
  */
#web_update web_ipaddr 		wifi_web_update
#web_update web_netmask 	wifi_web_update
#web_update web_router 		wifi_web_update
#web_update web_dhcp 		wifi_web_update
#web_update web_tx_pwr 		wifi_web_update
#web_update web_tx_rate 	wifi_web_update
#web_update web_http_port 	wifi_web_update
#web_update web_ssid		 	wifi_web_update


//----------------------------------------------------------------------------
root main()
{

	//measure variables
   char i,j, start;
   long T0, Tz, delay, a;
   tm_typ time;

   	Tz=0;
   	start = 0;
      yes_reset_meas = 'N';
      yes_format = 'N';
      for(i=0;i<6;i++)
      	meas_values[i]=-1;


   	_sysIsSoftReset();
	   brdInit();
	   pbledoff(LED4);
	   led_blink2(LED3, 500);


      fat_up();
      after_reset();
      if ((opt.wifi_opt_num > 2) | (opt.wifi_opt_num < 0))
      {
      	opt.wifi_opt_num = 0;
         opt_init();
      }
  	  //	wifi_up(opt.wifi_opt_num);


	   if(!(wifi_up(opt.wifi_opt_num))){
         opt.wifi_opt_num++;
         if(opt.wifi_opt_num>2){
         	opt.wifi_opt_num = 0;
            opt_save();
         }
         else{
         	opt_save();
         	forceSoftReset();
         }
      }
      http_up();
      wifi_opt_to_web();


	   if( chkSoftReset() ){
	      reset_count++;
	      log_add("Soft reset occured\n");
	   }
	   if(chkHardReset()){
	      log_add("Hard reset occured\n");
	      reset_count=0;
	   }
	   if(reset_count > 5)
	      pbledon(LED3);

      loopinit();
      serAopen(19200);
      serAwrite( "\r---------------------------------\r\n", 36);
      serAwrite(   "--- VODOMERKA 2.0 - WELLCOME! ---\r\n", 35);
      serAwrite(   "---   Type \"x??\" for help     ---\r\n", 35);
      serAwrite(   "---------------------------------\r\n", 35);

	   for(;;)
	   {
       	loophead();

         costate
	      {
	         mktm(&up_time, SEC_TIMER);
            wfd serial_cfg();
         	http_handler();
	         wfd DelaySec(1);
	      }

	      costate
	      {
	         wfd flashled[0](LED6, 5, 900); // blikani zelenou, jakoze to jede
	      }

	      costate
	      {
	 	  	  do{
	             wfd int_temp = temperature();
	             wfd ext_temp = ext_temperature();
	             start++;
	        } while(start<2);

	      	while(1){
	             waitfor(DelaySec(5)); // check everey 5sec
	             meas_sec_timer = SEC_TIMER;
	             mktm(&time, meas_sec_timer);
	             a = time.tm_min;
	             if( (a==0)|(a==10)|(a==20)|(a==30)|(a==40)|(a==50) )
	                break;
	         }
	         T0=MS_TIMER;
	         pbledon(LED4);
	         pbledon(LED5);
	         adc_value[0]=0; adc_value[1]=0; adc_value[2]=0; adc_value[3]=0;
	         wfd int_temp = temperature();
	         wfd ext_temp = ext_temperature();
	         wfd adc_measure(&adc_value);
	         adc_correction(&adc_value);
	         compute_adc_val(&meas_values, &adc_value);
	         meas_values[4] = int_temp;
	         meas_values[5] = ext_temp;

	#ifdef MY_DEBUG
	         mktm(&time, meas_sec_timer);
	         printf("-------------------------------\n");
	         printf("------ %d:%d:%d  %d.%d.%d ------ \n",  time.tm_hour, time.tm_min,
	                  time.tm_sec,time.tm_mday, time.tm_mon, time.tm_year+1900);
	         printf(" int temp = %fC\n", meas_values[4] );
	         printf(" ext temp = %fC\n", meas_values[5] );
	         printf("water: = %fmm\n",  meas_values[0]);
	         printf("  5V: = %fV\n", meas_values[1]);
	         printf("  3V: = %fV\n", meas_values[2]);
	         printf("RSSI: = %fV\n", meas_values[3]);
	         printf("-------------------------------\n");
	         log_add("zmerenooo :)\r\n");
	#endif
	        pbledoff(LED4);
	         meas_struct_update();
 	         meas_struct_save();
 	         xml_24_create();
  	         xml_week_create();
            actual_save();
            T0 = MS_TIMER - T0;
	         pbledoff(LED5);
	#ifdef MY_DEBUG
	         printf("measure executed in %f s\n", T0/1000.0);
	         printf("-------------------------------\n\n");
	#endif
	        waitfor(DelaySec(100)); // wait more than minute
	      }//cosate end
	   }//for end
}// main end


